<?php

class JavaScript extends Singleton {
    protected static $instance = false;
    protected $code = array();
    protected $onload = array();
    protected $files = array();

    public function add($code)
    {
	$this->code[] = $code;
    }

    public function onLoad($code)
    {
	$this->onload[] = $code;
    }

    public function file($path)
    {
	$app = Application::get();

	$info = pathinfo($path);

	$minfile = sprintf('%s%s/%s.min.%s', $app->getBaseDir(), $info['dirname'], $info['filename'], $info['extension']);
	if (file_exists($minfile)) {
	    $origpath = $app->getBaseDir().$path;
	    if (filemtime($minfile) > filemtime($origpath))
		$path = sprintf('%s/%s.min.%s', $info['dirname'], $info['filename'], $info['extension']);
	}

	$this->files[$path] = true;
    }

    public function toString()
    {
	$app = Application::get();

	$ret = '';
	foreach (array_keys($this->files) as $file)
	    $ret .= sprintf('<script type="text/javascript" src="%s%s"></script>'."\n", $app->getBaseURL(), $file);

	if (count($this->code) || count($this->onload)) {
	    $ret .= '<script type="text/javascript">'."\n";

	    if (count($this->code))
		$ret .= implode("\n", $this->code) . "\n";

	    if (count($this->onload)) {
		$ret .= "\$(function(){\n";
		$ret .= '  ' . str_replace("\n", "\n  ", implode("\n", $this->onload)) . "\n";
		$ret .= "});\n";
	    }
	    $ret .= "</script>\n";
	}

	return $ret;
    }
}