<?php

abstract class Singleton {
  protected static $instance = false;

  final public static function instance()
  {
    if (static::$instance === false) {
      $className = get_called_class();
      static::$instance = new $className();
    }

    return static::$instance;
  }

  final private function __construct() {
    if (method_exists($this, '___construct'))
      $this->___construct();
  }
}
