<?php

class Sys_User extends DatabaseTable
{
    public function __construct($id=false, $column=false)
    {
	parent::__construct('sys_user', $id, $column);
    }

    public function generateKey()
    {
	$key = md5(random_bytes(20));

	$this->modify(['pwkey' => $key,
		       'pwkey_valid' => 'now()']);
    }

    public function setPassword($passwd)
    {
	return $this->modify(['passwd' => md5($this->data->email.$passwd),
			      'pwkey' => NULL,
			      'pwkey_valid' => NULL]);
    }

    public function getUserlist($tour_id=false)
    {
	$tour_id = intval($tour_id);
	$sql =<<<EOS
	    SELECT DISTINCT
	      sys_user.id,sys_user.name,sys_user.email,tour_id IS NOT NULL AS active
	    FROM sys_user
	    LEFT JOIN tour_member ON sys_user.id = member_id
	                         AND ({$tour_id} = 0 OR tour_id = {$tour_id})
	    WHERE sys_user.id > 1 AND active = true
	    ORDER by sys_user.name
EOS;

	return $this->db->fetchObjectList($sql);
    }
}
