<?php

class Wiki
{
    public static function renderHTML($text)
    {
	if (is_null($text) || !strlen($text)) return NULL;

	$lines = preg_split('/\r?\n/', $text);

	foreach ($lines as &$line) {
	    if (!strlen($line)) continue;

	    $line = preg_replace(
				 [
				  '/^----$/',
				  '/===== (.*) =====/',
				  '/==== (.*) ====/',
				  '/=== (.*) ===/',
				  '/== (.*) ==/',
				  '/= (.*) =/',
				  '/^(.+)\[\[(https?:\/\/[^\]\|]+)\|([^\]]+)\]\]/',
				  '/^(.+)\[\[([^\]\|]+)\|([^\]]+)\]\]/',
				  '/^(.+)\[\[(https?:\/\/([^\]\|]+))\]\]/',
				  '/^(.+)\[\[([^\]\|]+)\]\]/',
				  '/^ \* (.*)/',
				  '/^ 1\. (.*)/',
				  "/'''''([^\']+)'''''/",
				  "/'''([^\']+)'''/",
				  "/''([^\']+)''/",
				  ],
				 [
				  '<hr>',
				  '<h5>${1}</h5>',
				  '<h4>${1}</h4>',
				  '<h3>${1}</h3>',
				  '<h2>${1}</h2>',
				  '<h1>${1}</h1>',
				  '${1}<a href="${2}" target="_blank">${3}</a>',
				  '${1}<a href="http://${2}" target="_blank">${3}</a>',
				  '${1}<a href="${2}" target="_blank">${3}</a>',
				  '${1}<a href="http://${2}" target="_blank">${2}</a>',
				  '<ul-li>${1}</li>',
				  '<ol-li>${1}</li>',
				  '<em><strong>${1}</strong></em>',
				  '<strong>${1}</strong>',
				  '<em>${1}</em>',
				  ],
				 $line);
	}

	for ($i=0; $i < count($lines); $i++) {
	    if (strpos($lines[$i], '<ul-li>') === 0) {
		for ($j=$i+1; $j < count($lines) && strpos($lines[$j], '<ul-li>') !== false; $j++);
		$lines[$i] = '<p><ul>' . $lines[$i];
		$lines[$j-1] = $lines[$j-1] . '</ul></p>';
		$i = $j-1;
	    } elseif (strpos($lines[$i], '<ol-li>') === 0) {
		for ($j=$i+1; $j < count($lines) && strpos($lines[$j], '<ol-li>') !== false; $j++);
		$lines[$i] = '<p><ol>' . $lines[$i];
		$lines[$j-1] = $lines[$j-1] . '</ol></p>';
		$i = $j-1;
	    } elseif  (strlen($lines[$i]) && strpos($lines[$i], '<') !== 0) {
		for ($j=$i+1; $j < count($lines) && (strlen($lines[$j]) && strpos($lines[$j], '<') !== 0); $j++);
		$lines[$i] = '<p>' . $lines[$i];
		$lines[$j-1] = $lines[$j-1] . '</p>';
		$i = $j-1;
	    }
	}

	foreach ($lines as &$line) {
	    if (!strlen($line)) continue;

	    $line = str_replace(['<ul-li>', '<ol-li>'], ['<li>', '<li>'], $line);
	}

	return implode('', $lines);
    }
}